
QGIS Application - Bug report #19355

$length incorrect in expressions

2018-07-07 03:31 PM - Gavin Fleming

Status: Closed

Priority: High

Assignee: Hugo Mercier

Category: Expressions

Affected QGIS version:3.5(master) Regression?: No

Operating System: Easy fix?: No

Pull Request or Patch supplied:No Resolution:

Crashes QGIS or corrupts data:No Copied to github as #: 27183

Description

$length correctly calculates ellipsoidal length in a field calculator update, but shows planimetric length in the expression dialog and if used

in expressions elsewhere, such as in labels.

Associated revisions

Revision 80919669 - 2019-02-14 01:40 PM - Hugo Mercier

Fix $length in labels (fixes #19355)

Use the project expression scope to access project

parameters (ellipsoid and distance/area units)

Revision aaed9ffa - 2019-02-18 11:36 AM - Hugo Mercier

Fix $length in labels (fixes #19355)

Use the project expression scope to access project

parameters (ellipsoid and distance/area units)

History

#1 - 2018-12-02 02:57 PM - Borys Jurgiel

- Operating System deleted (MacOS)

- Priority changed from Normal to High

This bug is definitely high priority, and misleading labels can be even considered as indirect data corruption.

On every training I teach users how to deal with this long standing issue, what becomes a bit embarrassing... :)

#2 - 2019-01-30 04:07 PM - Hugo Mercier

- File qgis_length_bug.png added

- Affected QGIS version changed from 3.2 to 3.5(master)

- File test_length.qgz added

- File test_length.gpkg added

Attached a sample project to reproduce, with one virtual field "length" with expression "$length" and labels using "$length || ' - ' || length"
#3 - 2019-01-30 04:39 PM - Hugo Mercier

- Assignee set to Hugo Mercier

#4 - 2019-02-14 02:33 PM - Hugo Mercier

- Status changed from Open to Closed

- % Done changed from 0 to 100

Applied in changeset commit:qgis|809196693c597eb86d1fceaec2e1ce483900adb1.

Files

test_length.gpkg 96 KB 2019-01-30 Hugo Mercier

test_length.qgz 5.15 KB 2019-01-30 Hugo Mercier

qgis_length_bug.png 15.9 KB 2019-01-30 Hugo Mercier
